//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd,com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    FastHullLength  = 15;
extern int    FastHullPrice   = PRICE_CLOSE;
extern int    SlowHullLength  = 30;
extern int    SlowHullPrice   = PRICE_CLOSE;

//
//
//
//
//

double hmha[];
double hmhb[];
double hma[];
double hmb[];
double trend[];

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,hmha); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,hmhb); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,hma);
      SetIndexBuffer(3,hmb);
      SetIndexBuffer(4,trend);
      
   //
   //
   //
   //
   //
         
   IndicatorShortName("Zero lag HMA CD ("+FastHullLength+","+SlowHullLength+")");         
   return(0);
}
int deinit() { return(0); }

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      double hma1   = iHma(iMA(NULL,0,1,0,MODE_SMA,FastHullPrice,i),FastHullLength,i,0);
      double hma2   = iHma(hma1                                    ,FastHullLength,i,1);
             hma[i] = 2.0*hma1-hma2;
             hma1   = iHma(iMA(NULL,0,1,0,MODE_SMA,SlowHullPrice,i),SlowHullLength,i,2);
             hma2   = iHma(hma1                                    ,SlowHullLength,i,3);
             hmb[i] = 2.0*hma1-hma2;

         //
         //
         //
         //
         //
         
         hmha[i] = EMPTY_VALUE;
         hmhb[i] = EMPTY_VALUE;
            if (hma[i] > hmb[i]) trend[i] =  1;
            if (hma[i] < hmb[i]) trend[i] = -1;
            if (trend[i] ==  1)  hmha[i]=1;
            if (trend[i] == -1)  hmhb[i]=1;
   }
   return(0);
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double wrk[][8];

//
//
//
//
//

double iHma(double price, int period, int i, int s=0)
{
   if (ArrayRange(wrk,0)!=Bars) ArrayResize(wrk,Bars);
   
   //
   //
   //
   //
   //
   
      int HMAPeriod  = MathMax(2,period);
      int HalfPeriod = MathFloor(HMAPeriod/2);
      int HullPeriod = MathFloor(MathSqrt(HMAPeriod));

      //
      //
      //
      //
      //

      s = s*2;         
      int r = Bars-i-1;  
         wrk[r][s  ] = price;
         wrk[r][s+1] = 2.0*iLwma(s,HalfPeriod,r)-iLwma(s,HMAPeriod,r);
      return (iLwma(s+1,HullPeriod,r));
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double iLwma(int forBuffer, int period, int r)
{
   double weight = 0;
   double sum    = 0;
   int    i,k;
   
   if (r>=period)
   {
      for (i=0, k=period; i<period; i++,k--)
      {
            weight += k; sum += wrk[r-i][forBuffer]*k;
      }
      if (weight !=0)
            return(sum/weight);
      else  return(0.0);
    }
    else return(wrk[r][forBuffer]);
}